﻿using C1.Win.C1Document;
using C1.Win.C1Document.Export;
using C1.Win.FlexReport;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace FlexReportByCode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            RenderEmployees();
            c1FlexViewer1.DocumentSource = c1FlexReport1;     
        }
        TextField textFld4 = new TextField();
        TextField textFld5 = new TextField();
        TextField textFld6 = new TextField();
        TextField textFld7 = new TextField();
        TextField textFld8 = new TextField();
        
        private void RenderEmployees()
        {
            c1FlexReport1.DataSource.RecordSourceType = RecordSourceType.Auto;
            // clear any existing fields  
            c1FlexReport1.Clear();
            // set default font for all controls
            c1FlexReport1.Font.Name = "Tahoma";
            c1FlexReport1.Font.Size = 8;

            //initialize DataSources          
            DataSource ds = c1FlexReport1.DataSource;
            ds.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0; Data Source="+Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)+@"\ComponentOne Samples\Common\C1NWind.mdb;";
            ds.RecordSource = "Employees";
           
            //initialize Layout
            Layout l = c1FlexReport1.Layout;
            l.Orientation = OrientationEnum.Portrait;
            l.Width = 6.5 * 1440; // 8.5 - margins, in twips
                                  // create a report header          
            Section s = c1FlexReport1.Sections[SectionTypeEnum.Header];
            s.Height = 1440;
            s.Visible = true;
            s.BackColor = Color.FromArgb(200, 200, 200);
            TextField textFld1 = new TextField();
            textFld1.Name = "FldTitle";
            textFld1.Text = "Employees Report";
            textFld1.Left = 0;
            textFld1.Top = 0;
            textFld1.Width = 8000;
            textFld1.Height = 1440;
            textFld1.Font.Size = 24;
            textFld1.Font.Bold = true;
            textFld1.ForeColor = Color.FromArgb(0, 0, 100);
            c1FlexReport1.Sections.Header.Fields.Add(textFld1);

            // create a page footer    
            s = c1FlexReport1.Sections[SectionTypeEnum.PageFooter];
            s.Height = 500;
            s.Visible = true;

            TextField textFld2 = new TextField();
            textFld2.Name = "FldFtrLeft";
            textFld2.Left = 0;
            textFld2.Top = 0;
            textFld2.Width = 4000;
            textFld2.Height = 300;
            textFld2.Font.Size = 8;
            textFld2.Font.Bold = false;
            c1FlexReport1.Sections.PageFooter.Fields.Add(textFld2);

            TextField textFld3 = new TextField();
            textFld3.Name = "FldFtrRight";
            textFld3.Left = 4000;
            textFld3.Top = 0;
            textFld3.Width = 4000;
            textFld3.Height = 300;
            textFld3.Align = FieldAlignEnum.RightTop;
            textFld3.Width = c1FlexReport1.Layout.Width - textFld3.Left;
            c1FlexReport1.Sections.PageFooter.Fields.Add(textFld3);

            //add a line before page footer
            ShapeField shpfld = new ShapeField();
            shpfld.Name = "FldLine";
            shpfld.ShapeType = ShapeType.Line;
            shpfld.Left = 0;
            shpfld.Top = 0;
            shpfld.Width = c1FlexReport1.Layout.Width;
            shpfld.Height = 20;
            c1FlexReport1.Sections.PageFooter.Fields.Add(shpfld);

            //create a page header with field labels   
            s = c1FlexReport1.Sections[SectionTypeEnum.PageHeader];
            s.Height = 500;
            s.Visible = true;
            c1FlexReport1.Font.Bold = true;

            textFld4.Name = "LblID";
            textFld4.Text = "ID";
            textFld4.Left = 0;
            textFld4.Top = 50;
            textFld4.Width = 400;
            textFld4.Height = 300;
            textFld4.Align = FieldAlignEnum.RightTop;
            c1FlexReport1.Sections.PageHeader.Fields.Add(textFld4);

            textFld5.Name = "LblFirstName";
            textFld5.Text = "First";
            textFld5.Left = 500;
            textFld5.Top = 50;
            textFld5.Width = 900;
            textFld5.Height = 300;
            c1FlexReport1.Sections.PageHeader.Fields.Add(textFld5);

            textFld6.Name = "LblLastName";
            textFld6.Text = "Last";
            textFld6.Left = 1500;
            textFld6.Top = 50;
            textFld6.Width = 900;
            textFld6.Height = 300;
            c1FlexReport1.Sections.PageHeader.Fields.Add(textFld6);

            textFld7.Name = "LblTitle";
            textFld7.Text = "Title";
            textFld7.Left = 2500;
            textFld7.Top = 50;
            textFld7.Width = 2400;
            textFld7.Height = 300;
            c1FlexReport1.Sections.PageHeader.Fields.Add(textFld7);

            
            textFld8.Name = "LblTitle";
            textFld8.Text = "Notes";
            textFld8.Left = 5000;
            textFld8.Top = 50;
            textFld8.Width = 8000;
            textFld8.Height = 300;
            c1FlexReport1.Sections.PageHeader.Fields.Add(textFld8);
            c1FlexReport1.Font.Bold = false;

            ShapeField shpfld2 = new ShapeField();
            shpfld2.Name = "FldLine";
            shpfld2.ShapeType = ShapeType.Line;
            shpfld2.Left = 0;
            shpfld2.Top = 400;
            shpfld2.Width = c1FlexReport1.Layout.Width;
            shpfld2.Height = 20;
            c1FlexReport1.Sections.PageHeader.Fields.Add(shpfld2);

            // create the Detail section   
            s = c1FlexReport1.Sections[SectionTypeEnum.Detail];
            s.Height = 330;
            s.Visible = true;
            
            TextField textField = new TextField();
            textField.Name = "FldID";
            textField.Text.Expression = "EmployeeID";
            textField.Left = 0;
            textField.Top = 0;
            textField.Width = 400;
            textField.Height = 300;
            c1FlexReport1.Sections.Detail.Fields.Add(textField);

            TextField textField1 = new TextField();
            textField1.Name = "FldFirstName";

            textField1.Text.Expression = "FirstName";
            textField1.Left = 500;
            textField1.Top = 0;
            textField1.Width = 900;
            textField1.Height = 300;
            c1FlexReport1.Sections.Detail.Fields.Add(textField1);

            TextField textField2 = new TextField();
            textField2.Name = "FldLastName";
            textField2.Text.Expression = "LastName";
            textField2.Left = 1500;
            textField2.Top = 0;
            textField2.Width = 900;
            textField2.Height = 300;
            c1FlexReport1.Sections.Detail.Fields.Add(textField2);

            TextField textField3 = new TextField();
            textField3.Name = "FldTitle";
            textField3.Text.Expression = "Title";
            textField3.Left = 2500;
            textField3.Top = 0;
            textField3.Width = 2400;
            textField3.Height = 300;
            c1FlexReport1.Sections.Detail.Fields.Add(textField3);

            TextField textField4 = new TextField();
            textField4.Name = "FldNotes";
            textField4.Text.Expression = "Notes";
            textField4.Left = 5000;
            textField4.Top = 0;
            textField4.Width = 8000;
            textField4.Height = 300;
            c1FlexReport1.Sections.Detail.Fields.Add(textField4);

            textField4.Width = c1FlexReport1.Layout.Width - textField4.Left;
            textField4.AutoHeight = AutoSizeBehavior.CanGrow;
            textField4.Font.Size = 6;
            textField4.Align = FieldAlignEnum.JustTop;

            //add a line after each field in detail section
            ShapeField shpfld3 = new ShapeField();
            shpfld3.Name = "FldLine";
            shpfld3.ShapeType = ShapeType.Line;
            shpfld3.Left = 0;
            shpfld3.Top = 310;
            shpfld3.Width = c1FlexReport1.Layout.Width;
            shpfld3.Height = 20;
            c1FlexReport1.Sections.Detail.Fields.Add(shpfld3);

        }
    }
}
